// for ECE 385 - University of Illinois - Electrical and Computer Engineering
// Author: Rauhul Varma, Rohan Mathur

// Macros to easily get key values from RAM
#define KEY_0 (*KEY_PIO & 0b00000001)
#define KEY_1 (*KEY_PIO & 0b00000010)
#define KEY_2 (*KEY_PIO & 0b00000100)
#define KEY_3 (*KEY_PIO & 0b00001000)

int main() {
	volatile unsigned int *LED_PIO = (unsigned int*)0x20; //make a pointer to access the LED PIO block
	volatile unsigned int *SW_PIO  = (unsigned int*)0x50; //make a pointer to access the SW  PIO block
	volatile unsigned int *KEY_PIO = (unsigned int*)0x60; //make a pointer to access the KEY PIO block

	*LED_PIO = 0; 						// clear all LEDs
	unsigned int sum = 0;				// clear sum

	while (1) { 						// run loop
		if (!KEY_2) {
			sum = 0; 					// clear sum
			*LED_PIO = sum;				// set LEDs
		}
		while (!KEY_2);					// wait for key press 2 to end

		if (!KEY_3) {
			sum += *SW_PIO;				// add switch value to sum
			if (sum > 255) {			// check for overflow
				sum -= 255;				// remove overflow
			}
			*LED_PIO = sum;				// set LEDs
		}
		while (!KEY_3);					// wait for key press 3 to end
	}
	return 1; 							//never gets here
}
